
USE AdventureWorks ;
GO

-- copy the employee table
SELECT EmployeeID, LoginID, ManagerID, Title, HireDate 
INTO HumanResources.EmployeeDemo 
FROM HumanResources.Employee;
GO

-- show employee-manager relationships
SELECT 
     Mgr.EmployeeID AS MgrID, Mgr.LoginID AS Manager, 
     Emp.EmployeeID AS EmpID, Emp.LoginID, Emp.Title
FROM HumanResources.EmployeeDemo AS Emp
LEFT JOIN HumanResources.EmployeeDemo AS Mgr
ON Emp.ManagerID = Mgr.EmployeeID
ORDER BY MgrID, EmpID;
GO