
USE AdventureWorks
GO

CREATE PROCEDURE MoveOrg(@oldMgr nvarchar(256), @newMgr nvarchar(256) )
AS
BEGIN
DECLARE @nold hierarchyid, @nnew hierarchyid
SELECT @nold = OrgNode FROM HumanResources.NewOrg WHERE LoginID = @oldMgr ;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE
BEGIN TRANSACTION
SELECT @nnew = OrgNode FROM HumanResources.NewOrg WHERE LoginID = @newMgr ;

SELECT @nnew = @nnew.GetDescendant(max(OrgNode), NULL) 
FROM HumanResources.NewOrg WHERE OrgNode.GetAncestor(1)=@nnew ;

UPDATE HumanResources.NewOrg  
SET OrgNode = OrgNode.GetReparentedValue(@nold, @nnew)
WHERE OrgNode.IsDescendantOf(@nold) = 1 ;

COMMIT TRANSACTION
SET TRANSACTION ISOLATION LEVEL READ COMMITTED

END ;
GO

SELECT OrgNode.ToString() AS LogicalNode,
OrgNode, H_Level, EmployeeID, LoginID, Title
FROM HumanResources.NewOrg 
ORDER BY OrgNode;
GO

execute MoveOrg 'adventure-works\stephanie0', 'adventure-works\david0'