
use adventureworks2008
go

-- IsDescendant is transformed into a range seek


-- GetAncestor is transformed into a range scan and a residual predicate
DECLARE @value int = 6
SELECT * FROM Employees WHERE EmployeeId.GetAncestor(1) = @value

-- transformed into this (DescendantLimit is an internal function)
SELECT * FROM Employees 
WHERE 
   EmployeeId >= @Value AND EmployeeId <= @value.DescendantLimit() 
   AND EmployeeId.GetAncestor(1) = @value

-- Example: Last query in this sequence
-- The first Step (ClusteredIndexSeek) is the range scan
-- The Filter step is the residual predicate
DECLARE @CurrentEmployee hierarchyid
SELECT @CurrentEmployee = OrgNode FROM HumanResources.EmployeeDemo
WHERE LoginID = 'adventure-works\david0'

SELECT OrgNode.ToString() AS Text_OrgNode, *
FROM HumanResources.EmployeeDemo
WHERE OrgNode.GetAncestor(1) = @CurrentEmployee ;


-- GetAncestor transformed into an index lookup using a breadth-first index
SELECT * FROM Employees 
WHERE 
   EmployeeId >=@value AND EmployeeId <= @Value.DescendantLimit() 
   AND @value.GetLevel()+1 = EmployeeId.GetLevel()



